diff -rupN keepalived-1.2.7/keepalived/check/ipvswrapper.c keepalived-1.2.7-unicast/keepalived/check/ipvswrapper.c
--- keepalived-1.2.7/keepalived/check/ipvswrapper.c	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/ipvswrapper.c	2013-05-24 10:12:36.518162100 +0200
@@ -34,11 +34,11 @@ static int string_to_number(const char *
 static int modprobe_ipvs(void);
 
 /* fetch virtual server group from group name */
-virtual_server_group *
+virtual_server_group_t *
 ipvs_get_group_by_name(char *gname, list l)
 {
 	element e;
-	virtual_server_group *vsg;
+	virtual_server_group_t *vsg;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vsg = ELEMENT_DATA(e);
@@ -119,7 +119,7 @@ ipvs_syncd_cmd(int cmd, char *ifname, in
 
 /* IPVS group range rule */
 static int
-ipvs_group_range_cmd(int cmd, virtual_server_group_entry *vsg_entry)
+ipvs_group_range_cmd(int cmd, virtual_server_group_entry_t *vsg_entry)
 {
 	uint32_t addr_ip;
 	int err = 0;
@@ -140,10 +140,10 @@ ipvs_group_range_cmd(int cmd, virtual_se
 
 /* set IPVS group rules */
 static int
-ipvs_group_cmd(int cmd, list vs_group, real_server * rs, char * vsgname)
+ipvs_group_cmd(int cmd, list vs_group, real_server_t * rs, char * vsgname)
 {
-	virtual_server_group *vsg = ipvs_get_group_by_name(vsgname, vs_group);
-	virtual_server_group_entry *vsg_entry;
+	virtual_server_group_t *vsg = ipvs_get_group_by_name(vsgname, vs_group);
+	virtual_server_group_entry_t *vsg_entry;
 	list l;
 	element e;
 	int err = 1;
@@ -198,7 +198,7 @@ ipvs_group_cmd(int cmd, list vs_group, r
 
 /* Fill IPVS rule with root vs infos */
 void
-ipvs_set_rule(int cmd, virtual_server * vs, real_server * rs)
+ipvs_set_rule(int cmd, virtual_server_t * vs, real_server_t * rs)
 {
 	/* Clean up target rule */
 	memset(urule, 0, sizeof (struct ip_vs_rule_user));
@@ -235,7 +235,7 @@ ipvs_set_rule(int cmd, virtual_server *
 
 /* Set/Remove a RS from a VS */
 int
-ipvs_cmd(int cmd, list vs_group, virtual_server * vs, real_server * rs)
+ipvs_cmd(int cmd, list vs_group, virtual_server_t * vs, real_server_t * rs)
 {
 	int err = 0;
 
@@ -276,9 +276,9 @@ ipvs_cmd(int cmd, list vs_group, virtual
 
 /* Remove a specific vs group entry */
 int
-ipvs_group_remove_entry(virtual_server *vs, virtual_server_group_entry *vsge)
+ipvs_group_remove_entry(virtual_server_t *vs, virtual_server_group_entry_t *vsge)
 {
-	real_server *rs;
+	real_server_t *rs;
 	int err = 0;
 	element e;
 	list l = vs->rs;
@@ -421,7 +421,7 @@ ipvs_syncd_cmd(int cmd, char *ifname, in
 
 /* IPVS group range rule */
 static void
-ipvs_group_range_cmd(int cmd, virtual_server_group_entry *vsg_entry)
+ipvs_group_range_cmd(int cmd, virtual_server_group_entry_t *vsg_entry)
 {
 	uint32_t addr_ip, ip;
 
@@ -455,10 +455,10 @@ ipvs_group_range_cmd(int cmd, virtual_se
 
 /* set IPVS group rules */
 static void
-ipvs_group_cmd(int cmd, list vs_group, real_server * rs, virtual_server * vs)
+ipvs_group_cmd(int cmd, list vs_group, real_server_t * rs, virtual_server_t * vs)
 {
-	virtual_server_group *vsg = ipvs_get_group_by_name(vs->vsgname, vs_group);
-	virtual_server_group_entry *vsg_entry;
+	virtual_server_group_t *vsg = ipvs_get_group_by_name(vs->vsgname, vs_group);
+	virtual_server_group_entry_t *vsg_entry;
 	list l;
 	element e;
 
@@ -495,7 +495,7 @@ ipvs_group_cmd(int cmd, list vs_group, r
 		srule->af = AF_INET;
 		/* Need to get address family from first real server */
 		if (vs->rs && !LIST_ISEMPTY(vs->rs) &&
-		    (((real_server *)ELEMENT_DATA(LIST_HEAD(vs->rs)))->addr.ss_family == AF_INET6)) {
+		    (((real_server_t *)ELEMENT_DATA(LIST_HEAD(vs->rs)))->addr.ss_family == AF_INET6)) {
 			srule->af = AF_INET6;
 			srule->netmask = 128;
 		}
@@ -524,7 +524,7 @@ ipvs_group_cmd(int cmd, list vs_group, r
 
 /* Fill IPVS rule with root vs infos */
 void
-ipvs_set_rule(int cmd, virtual_server * vs, real_server * rs)
+ipvs_set_rule(int cmd, virtual_server_t * vs, real_server_t * rs)
 {
 	/* Clean target rule */
 	memset(drule, 0, sizeof(ipvs_dest_t));
@@ -568,7 +568,7 @@ ipvs_set_rule(int cmd, virtual_server *
 
 /* Set/Remove a RS from a VS */
 int
-ipvs_cmd(int cmd, list vs_group, virtual_server * vs, real_server * rs)
+ipvs_cmd(int cmd, list vs_group, virtual_server_t * vs, real_server_t * rs)
 {
 	/* Allocate the room */
 	memset(srule, 0, sizeof(ipvs_service_t));
@@ -596,7 +596,7 @@ ipvs_cmd(int cmd, list vs_group, virtual
 			srule->af = AF_INET;
 			/* Need to get address family from first real server */
 			if (vs->rs && !LIST_ISEMPTY(vs->rs) &&
-			    (((real_server *)ELEMENT_DATA(LIST_HEAD(vs->rs)))->addr.ss_family == AF_INET6)) {
+			    (((real_server_t *)ELEMENT_DATA(LIST_HEAD(vs->rs)))->addr.ss_family == AF_INET6)) {
 				srule->af = AF_INET6;
 				srule->netmask = 128;
 			}
@@ -619,9 +619,9 @@ ipvs_cmd(int cmd, list vs_group, virtual
 
 /* Remove a specific vs group entry */
 int
-ipvs_group_remove_entry(virtual_server *vs, virtual_server_group_entry *vsge)
+ipvs_group_remove_entry(virtual_server_t *vs, virtual_server_group_entry_t *vsge)
 {
-	real_server *rs;
+	real_server_t *rs;
 	element e;
 	list l = vs->rs;
 
@@ -682,12 +682,12 @@ ipvs_group_remove_entry(virtual_server *
    statistics of real servers. The update is only done if we need
    refreshing. */
 void
-ipvs_update_stats(virtual_server *vs)
+ipvs_update_stats(virtual_server_t *vs)
 {
 	element e, ge = NULL;
-	real_server *rs;
-	virtual_server_group *vsg = NULL;
-	virtual_server_group_entry *vsg_entry = NULL;
+	real_server_t *rs;
+	virtual_server_group_t *vsg = NULL;
+	virtual_server_group_entry_t *vsg_entry = NULL;
 	uint32_t addr_ip = 0;
 	union nf_inet_addr nfaddr;
 	ipvs_service_entry_t * serv = NULL;
diff -rupN keepalived-1.2.7/keepalived/check/ipwrapper.c keepalived-1.2.7-unicast/keepalived/check/ipwrapper.c
--- keepalived-1.2.7/keepalived/check/ipwrapper.c	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/ipwrapper.c	2013-05-24 10:12:36.520162200 +0200
@@ -33,10 +33,10 @@
 
 /* Returns the sum of all RS weight in a virtual server. */
 long unsigned
-weigh_live_realservers(virtual_server * vs)
+weigh_live_realservers(virtual_server_t * vs)
 {
 	element e;
-	real_server *svr;
+	real_server_t *svr;
 	long unsigned count = 0;
 
 	for (e = LIST_HEAD(vs->rs); e; ELEMENT_NEXT(e)) {
@@ -49,10 +49,10 @@ weigh_live_realservers(virtual_server *
 
 /* Remove a realserver IPVS rule */
 static int
-clear_service_rs(list vs_group, virtual_server * vs, list l)
+clear_service_rs(list vs_group, virtual_server_t * vs, list l)
 {
 	element e;
-	real_server *rs;
+	real_server_t *rs;
 	char rsip[INET6_ADDRSTRLEN];
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
@@ -106,7 +106,7 @@ clear_service_rs(list vs_group, virtual_
 
 /* Remove a virtualserver IPVS rule */
 static int
-clear_service_vs(list vs_group, virtual_server * vs)
+clear_service_vs(list vs_group, virtual_server_t * vs)
 {
 	/* Processing real server queue */
 	if (!LIST_ISEMPTY(vs->rs)) {
@@ -132,7 +132,7 @@ clear_services(void)
 {
 	element e;
 	list l = check_data->vs;
-	virtual_server *vs;
+	virtual_server_t *vs;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vs = ELEMENT_DATA(e);
@@ -144,10 +144,10 @@ clear_services(void)
 
 /* Set a realserver IPVS rules */
 static int
-init_service_rs(virtual_server * vs)
+init_service_rs(virtual_server_t * vs)
 {
 	element e;
-	real_server *rs;
+	real_server_t *rs;
 
 	for (e = LIST_HEAD(vs->rs); e; ELEMENT_NEXT(e)) {
 		rs = ELEMENT_DATA(e);
@@ -177,7 +177,7 @@ init_service_rs(virtual_server * vs)
 
 /* Set a virtualserver IPVS rules */
 static int
-init_service_vs(virtual_server * vs)
+init_service_vs(virtual_server_t * vs)
 {
 	/* Init the VS root */
 	if (!ISALIVE(vs) || vs->vsgname) {
@@ -203,7 +203,7 @@ init_services(void)
 {
 	element e;
 	list l = check_data->vs;
-	virtual_server *vs;
+	virtual_server_t *vs;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vs = ELEMENT_DATA(e);
@@ -215,10 +215,10 @@ init_services(void)
 
 /* add or remove _alive_ real servers from a virtual server */
 void
-perform_quorum_state(virtual_server *vs, int add)
+perform_quorum_state(virtual_server_t *vs, int add)
 {
 	element e;
-	real_server *rs;
+	real_server_t *rs;
 
 	if (LIST_ISEMPTY(vs->rs))
 		return;
@@ -240,7 +240,7 @@ perform_quorum_state(virtual_server *vs,
 
 /* set quorum state depending on current weight of real servers */
 void
-update_quorum_state(virtual_server * vs)
+update_quorum_state(virtual_server_t * vs)
 {
 	char rsip[INET6_ADDRSTRLEN];
 
@@ -324,7 +324,7 @@ update_quorum_state(virtual_server * vs)
 
 /* manipulate add/remove rs according to alive state */
 void
-perform_svr_state(int alive, virtual_server * vs, real_server * rs)
+perform_svr_state(int alive, virtual_server_t * vs, real_server_t * rs)
 {
 	char rsip[INET6_ADDRSTRLEN];
 
@@ -399,7 +399,7 @@ perform_svr_state(int alive, virtual_ser
 
 /* Store new weight in real_server struct and then update kernel. */
 void
-update_svr_wgt(int weight, virtual_server * vs, real_server * rs)
+update_svr_wgt(int weight, virtual_server_t * vs, real_server_t * rs)
 {
 	char rsip[INET6_ADDRSTRLEN];
 
@@ -428,7 +428,7 @@ update_svr_wgt(int weight, virtual_serve
 
 /* Test if realserver is marked UP for a specific checker */
 int
-svr_checker_up(checker_id_t cid, real_server *rs)
+svr_checker_up(checker_id_t cid, real_server_t *rs)
 {
 	element e;
 	list l = rs->failed_checkers;
@@ -450,7 +450,7 @@ svr_checker_up(checker_id_t cid, real_se
 
 /* Update checker's state */
 void
-update_svr_checker_state(int alive, checker_id_t cid, virtual_server *vs, real_server *rs)
+update_svr_checker_state(int alive, checker_id_t cid, virtual_server_t *vs, real_server_t *rs)
 {
 	element e;
 	list l = rs->failed_checkers;
@@ -487,10 +487,10 @@ update_svr_checker_state(int alive, chec
 
 /* Check if a vsg entry is in new data */
 static int
-vsge_exist(virtual_server_group_entry *vsg_entry, list l)
+vsge_exist(virtual_server_group_entry_t *vsg_entry, list l)
 {
 	element e;
-	virtual_server_group_entry *vsge;
+	virtual_server_group_entry_t *vsge;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vsge = ELEMENT_DATA(e);
@@ -510,9 +510,9 @@ vsge_exist(virtual_server_group_entry *v
 
 /* Clear the diff vsge of old group */
 static int
-clear_diff_vsge(list old, list new, virtual_server * old_vs)
+clear_diff_vsge(list old, list new, virtual_server_t * old_vs)
 {
-	virtual_server_group_entry *vsge;
+	virtual_server_group_entry_t *vsge;
 	element e;
 
 	for (e = LIST_HEAD(old); e; ELEMENT_NEXT(e)) {
@@ -535,10 +535,10 @@ clear_diff_vsge(list old, list new, virt
 
 /* Clear the diff vsg of the old vs */
 static int
-clear_diff_vsg(virtual_server * old_vs)
+clear_diff_vsg(virtual_server_t * old_vs)
 {
-	virtual_server_group *old;
-	virtual_server_group *new;
+	virtual_server_group_t *old;
+	virtual_server_group_t *new;
 
 	/* Fetch group */
 	old = ipvs_get_group_by_name(old_vs->vsgname, old_check_data->vs_group);
@@ -557,12 +557,12 @@ clear_diff_vsg(virtual_server * old_vs)
 
 /* Check if a vs exist in new data */
 static int
-vs_exist(virtual_server * old_vs)
+vs_exist(virtual_server_t * old_vs)
 {
 	element e;
 	list l = check_data->vs;
-	virtual_server *vs;
-	virtual_server_group *vsg;
+	virtual_server_t *vs;
+	virtual_server_group_t *vsg;
 
 	if (LIST_ISEMPTY(l))
 		return 0;
@@ -594,10 +594,10 @@ vs_exist(virtual_server * old_vs)
 
 /* Check if rs is in new vs data */
 static int
-rs_exist(real_server * old_rs, list l)
+rs_exist(real_server_t * old_rs, list l)
 {
 	element e;
-	real_server *rs;
+	real_server_t *rs;
 
 	if (LIST_ISEMPTY(l))
 		return 0;
@@ -622,11 +622,11 @@ rs_exist(real_server * old_rs, list l)
 
 /* get rs list for a specific vs */
 static list
-get_rs_list(virtual_server * vs)
+get_rs_list(virtual_server_t * vs)
 {
 	element e;
 	list l = check_data->vs;
-	virtual_server *vsvr;
+	virtual_server_t *vsvr;
 
 	if (LIST_ISEMPTY(l))
 		return NULL;
@@ -643,12 +643,12 @@ get_rs_list(virtual_server * vs)
 
 /* Clear the diff rs of the old vs */
 static int
-clear_diff_rs(virtual_server * old_vs)
+clear_diff_rs(virtual_server_t * old_vs)
 {
 	element e;
 	list l = old_vs->rs;
 	list new = get_rs_list(old_vs);
-	real_server *rs;
+	real_server_t *rs;
 	char rsip[INET6_ADDRSTRLEN];
 
 	/* If old vs didn't own rs then nothing return */
@@ -682,7 +682,7 @@ clear_diff_services(void)
 {
 	element e;
 	list l = old_check_data->vs;
-	virtual_server *vs;
+	virtual_server_t *vs;
 
 	/* If old config didn't own vs then nothing return */
 	if (LIST_ISEMPTY(l))
diff -rupN keepalived-1.2.7/keepalived/core/global_data.c keepalived-1.2.7-unicast/keepalived/core/global_data.c
--- keepalived-1.2.7/keepalived/core/global_data.c	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/core/global_data.c	2013-05-24 10:12:36.526162500 +0200
@@ -31,11 +31,11 @@
 #include "utils.h"
 
 /* global vars */
-conf_data_t *global_data = NULL;
+data_t *global_data = NULL;
 
 /* Default settings */
 static void
-set_default_router_id(conf_data_t * data)
+set_default_router_id(data_t * data)
 {
 	char *new_id = NULL;
 	int len = 0;
@@ -53,7 +53,7 @@ set_default_router_id(conf_data_t * data
 }
 
 static void
-set_default_email_from(conf_data_t * data)
+set_default_email_from(data_t * data)
 {
 	struct passwd *pwd = NULL;
 	char *hostname = NULL;
@@ -76,13 +76,13 @@ set_default_email_from(conf_data_t * dat
 }
 
 static void
-set_default_smtp_connection_timeout(conf_data_t * data)
+set_default_smtp_connection_timeout(data_t * data)
 {
 	data->smtp_connection_to = DEFAULT_SMTP_CONNECTION_TIMEOUT;
 }
 
 static void
-set_default_values(conf_data_t * data)
+set_default_values(data_t * data)
 {
 	/* No global data so don't default */
 	if (!data)
@@ -94,14 +94,14 @@ set_default_values(conf_data_t * data)
 
 /* email facility functions */
 static void
-free_email(void *data_obj)
+free_email(void *data)
 {
-	FREE(data_obj);
+	FREE(data);
 }
 static void
-dump_email(void *data_obj)
+dump_email(void *data)
 {
-	char *addr = data_obj;
+	char *addr = data;
 	log_message(LOG_INFO, " Email notification = %s", addr);
 }
 
@@ -118,12 +118,12 @@ alloc_email(char *addr)
 }
 
 /* data facility functions */
-conf_data_t *
+data_t *
 alloc_global_data(void)
 {
-	conf_data_t *new;
+	data_t *new;
 
-	new = (conf_data_t *) MALLOC(sizeof (conf_data_t));
+	new = (data_t *) MALLOC(sizeof(data_t));
 	new->email = alloc_list(free_email, dump_email);
 
 	set_default_values(new);
@@ -131,7 +131,7 @@ alloc_global_data(void)
 }
 
 void
-free_global_data(conf_data_t * data)
+free_global_data(data_t * data)
 {
 	free_list(data->email);
 	FREE_PTR(data->router_id);
@@ -141,7 +141,7 @@ free_global_data(conf_data_t * data)
 }
 
 void
-dump_global_data(conf_data_t * data)
+dump_global_data(data_t * data)
 {
 	if (!data)
 		return;
